use 5.006;
use strict;
use warnings;

# this test was generated with Dist::Zilla::Plugin::Test::Compile 2.058

use Test::More;

plan tests => 44 + ($ENV{AUTHOR_TESTING} ? 1 : 0);

my @module_files = (
    'App/TextTableUtils.pm'
);

my @scripts = (
    'script/csv2ansitable',
    'script/csv2asciitable',
    'script/csv2dd',
    'script/csv2json',
    'script/csv2mdtable',
    'script/csv2orgtable',
    'script/csv2texttable',
    'script/dd2ansitable',
    'script/dd2asciitable',
    'script/dd2csv',
    'script/dd2mdtable',
    'script/dd2orgtable',
    'script/dd2texttable',
    'script/dd2tsv',
    'script/ini2ansitable',
    'script/ini2asciitable',
    'script/ini2csv',
    'script/ini2mdtable',
    'script/ini2orgtable',
    'script/ini2texttable',
    'script/ini2tsv',
    'script/iod2ansitable',
    'script/iod2asciitable',
    'script/iod2csv',
    'script/iod2mdtable',
    'script/iod2orgtable',
    'script/iod2texttable',
    'script/iod2tsv',
    'script/json2ansitable',
    'script/json2asciitable',
    'script/json2csv',
    'script/json2mdtable',
    'script/json2orgtable',
    'script/json2texttable',
    'script/json2tsv',
    'script/texttableutils-convert',
    'script/tsv2ansitable',
    'script/tsv2asciitable',
    'script/tsv2dd',
    'script/tsv2json',
    'script/tsv2mdtable',
    'script/tsv2orgtable',
    'script/tsv2texttable'
);

# no fake home requested

my @switches = (
    -d 'blib' ? '-Mblib' : '-Ilib',
);

use File::Spec;
use IPC::Open3;
use IO::Handle;

open my $stdin, '<', File::Spec->devnull or die "can't open devnull: $!";

my @warnings;
for my $lib (@module_files)
{
    # see L<perlfaq8/How can I capture STDERR from an external command?>
    my $stderr = IO::Handle->new;

    diag('Running: ', join(', ', map { my $str = $_; $str =~ s/'/\\'/g; q{'} . $str . q{'} }
            $^X, @switches, '-e', "require q[$lib]"))
        if $ENV{PERL_COMPILE_TEST_DEBUG};

    my $pid = open3($stdin, '>&STDERR', $stderr, $^X, @switches, '-e', "require q[$lib]");
    binmode $stderr, ':crlf' if $^O eq 'MSWin32';
    my @_warnings = <$stderr>;
    waitpid($pid, 0);
    is($?, 0, "$lib loaded ok");

    shift @_warnings if @_warnings and $_warnings[0] =~ /^Using .*\bblib/
        and not eval { +require blib; blib->VERSION('1.01') };

    if (@_warnings)
    {
        warn @_warnings;
        push @warnings, @_warnings;
    }
}

foreach my $file (@scripts)
{ SKIP: {
    open my $fh, '<', $file or warn("Unable to open $file: $!"), next;
    my $line = <$fh>;

    close $fh and skip("$file isn't perl", 1) unless $line =~ /^#!\s*(?:\S*perl\S*)((?:\s+-\w*)*)(?:\s*#.*)?$/;
    @switches = (@switches, split(' ', $1)) if $1;

    close $fh and skip("$file uses -T; not testable with PERL5LIB", 1)
        if grep { $_ eq '-T' } @switches and $ENV{PERL5LIB};

    my $stderr = IO::Handle->new;

    diag('Running: ', join(', ', map { my $str = $_; $str =~ s/'/\\'/g; q{'} . $str . q{'} }
            $^X, @switches, '-c', $file))
        if $ENV{PERL_COMPILE_TEST_DEBUG};

    my $pid = open3($stdin, '>&STDERR', $stderr, $^X, @switches, '-c', $file);
    binmode $stderr, ':crlf' if $^O eq 'MSWin32';
    my @_warnings = <$stderr>;
    waitpid($pid, 0);
    is($?, 0, "$file compiled ok");

    shift @_warnings if @_warnings and $_warnings[0] =~ /^Using .*\bblib/
        and not eval { +require blib; blib->VERSION('1.01') };

    # in older perls, -c output is simply the file portion of the path being tested
    if (@_warnings = grep { !/\bsyntax OK$/ }
        grep { chomp; $_ ne (File::Spec->splitpath($file))[2] } @_warnings)
    {
        warn @_warnings;
        push @warnings, @_warnings;
    }
} }



is(scalar(@warnings), 0, 'no warnings found')
    or diag 'got warnings: ', ( Test::More->can('explain') ? Test::More::explain(\@warnings) : join("\n", '', @warnings) ) if $ENV{AUTHOR_TESTING};


